searchData={"content_type":"text/markdown","items":[{"doc":"The main ReverseProxyPlug module.","ref":"ReverseProxyPlug.html","title":"ReverseProxyPlug","type":"module"},{"doc":"","ref":"ReverseProxyPlug.html#call/2","title":"ReverseProxyPlug.call/2","type":"function"},{"doc":"","ref":"ReverseProxyPlug.html#downcase_headers/1","title":"ReverseProxyPlug.downcase_headers/1","type":"function"},{"doc":"","ref":"ReverseProxyPlug.html#init/1","title":"ReverseProxyPlug.init/1","type":"function"},{"doc":"","ref":"ReverseProxyPlug.html#read_body/2","title":"ReverseProxyPlug.read_body/2","type":"function"},{"doc":"","ref":"ReverseProxyPlug.html#request/3","title":"ReverseProxyPlug.request/3","type":"function"},{"doc":"","ref":"ReverseProxyPlug.html#response/3","title":"ReverseProxyPlug.response/3","type":"function"},{"doc":"Behaviour defining the HTTP client interface needed for reverse proxying.","ref":"ReverseProxyPlug.HTTPClient.html","title":"ReverseProxyPlug.HTTPClient","type":"behaviour"},{"doc":"","ref":"ReverseProxyPlug.HTTPClient.html#c:request/1","title":"ReverseProxyPlug.HTTPClient.request/1","type":"callback"},{"doc":"","ref":"ReverseProxyPlug.HTTPClient.html#c:request_stream/1","title":"ReverseProxyPlug.HTTPClient.request_stream/1","type":"callback"},{"doc":"","ref":"ReverseProxyPlug.HTTPClient.html#t:error/0","title":"ReverseProxyPlug.HTTPClient.error/0","type":"type"},{"doc":"Finch adapter for the `ReverseProxyPlug.HTTPClient` behaviour\n\nOnly synchronous responses are supported.","ref":"ReverseProxyPlug.HTTPClient.Adapters.Finch.html","title":"ReverseProxyPlug.HTTPClient.Adapters.Finch","type":"module"},{"doc":"* `:finch_client` - Finch client available in the supervision tree.","ref":"ReverseProxyPlug.HTTPClient.Adapters.Finch.html#module-options","title":"Options - ReverseProxyPlug.HTTPClient.Adapters.Finch","type":"module"},{"doc":"HTTPoison adapter for the `ReverseProxyPlug.HTTPClient` behaviour","ref":"ReverseProxyPlug.HTTPClient.Adapters.HTTPoison.html","title":"ReverseProxyPlug.HTTPClient.Adapters.HTTPoison","type":"module"},{"doc":"Req adapter for the `ReverseProxyPlug.HTTPClient` behaviour\n\nBuffer resposne mode is supported for all Req versions.\n\nStream response mode is supported for Req 0.4.0 and up, when using\nthe Finch adapter.\n\nSee the [Req documentation](https://hexdocs.pm/req/Req.html#new/1) for client-specific options.","ref":"ReverseProxyPlug.HTTPClient.Adapters.Req.html","title":"ReverseProxyPlug.HTTPClient.Adapters.Req","type":"module"},{"doc":"Tesla adapter for the `ReverseProxyPlug.HTTPClient` behaviour\n\nBuffer response mode is supported for all Tesla versions.\n\nStream response mode is supported for Tesla 1.9.0 and up when using\nthe Finch adapter.","ref":"ReverseProxyPlug.HTTPClient.Adapters.Tesla.html","title":"ReverseProxyPlug.HTTPClient.Adapters.Tesla","type":"module"},{"doc":"* `:tesla_client` - mandatory definition for the `Tesla.Client`\n                    to be used.","ref":"ReverseProxyPlug.HTTPClient.Adapters.Tesla.html#module-options","title":"Options - ReverseProxyPlug.HTTPClient.Adapters.Tesla","type":"module"},{"doc":"If the option `:follow_redirect` is given to a request, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or `307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this struct is returned in place of a\n`ReverseProxyPlug.HTTPClient.Response` or `ReverseProxyPlug.HTTPClient.AsyncResponse`, containing the `redirect_url` to allow you\nto optionally re-request with the method set to `:get`.","ref":"ReverseProxyPlug.HTTPClient.MaybeRedirect.html","title":"ReverseProxyPlug.HTTPClient.MaybeRedirect","type":"module"},{"doc":"","ref":"ReverseProxyPlug.HTTPClient.MaybeRedirect.html#t:t/0","title":"ReverseProxyPlug.HTTPClient.MaybeRedirect.t/0","type":"type"},{"doc":"`Request` properties:\n  * `:method` - HTTP method as an atom (`:get`, `:head`, `:post`, `:put`,\n    `:delete`, etc.)\n  * `:url` - target url as a binary string or char list\n  * `:body` - request body.\n  * `:headers` - HTTP headers as an orddict (e.g., `[{\"Accept\", \"application/json\"}]`)\n  * `:options` - Keyword list of options. Valid options vary with the HTTP client used.\n  * `:query_params` - Query parameters as a map, keyword, or orddict\n  * `:cookies` - the original request's cookie string, in case an adapter needs to pass this in another form\n\nThe exact typing for each of the parameters depends on the adapter used.","ref":"ReverseProxyPlug.HTTPClient.Request.html","title":"ReverseProxyPlug.HTTPClient.Request","type":"module"},{"doc":"","ref":"ReverseProxyPlug.HTTPClient.Request.html#t:body/0","title":"ReverseProxyPlug.HTTPClient.Request.body/0","type":"type"},{"doc":"","ref":"ReverseProxyPlug.HTTPClient.Request.html#t:cookies/0","title":"ReverseProxyPlug.HTTPClient.Request.cookies/0","type":"type"},{"doc":"","ref":"ReverseProxyPlug.HTTPClient.Request.html#t:headers/0","title":"ReverseProxyPlug.HTTPClient.Request.headers/0","type":"type"},{"doc":"","ref":"ReverseProxyPlug.HTTPClient.Request.html#t:method/0","title":"ReverseProxyPlug.HTTPClient.Request.method/0","type":"type"},{"doc":"","ref":"ReverseProxyPlug.HTTPClient.Request.html#t:options/0","title":"ReverseProxyPlug.HTTPClient.Request.options/0","type":"type"},{"doc":"","ref":"ReverseProxyPlug.HTTPClient.Request.html#t:query_params/0","title":"ReverseProxyPlug.HTTPClient.Request.query_params/0","type":"type"},{"doc":"","ref":"ReverseProxyPlug.HTTPClient.Request.html#t:t/0","title":"ReverseProxyPlug.HTTPClient.Request.t/0","type":"type"},{"doc":"","ref":"ReverseProxyPlug.HTTPClient.Request.html#t:url/0","title":"ReverseProxyPlug.HTTPClient.Request.url/0","type":"type"},{"doc":"HTTP Client response model","ref":"ReverseProxyPlug.HTTPClient.Response.html","title":"ReverseProxyPlug.HTTPClient.Response","type":"module"},{"doc":"","ref":"ReverseProxyPlug.HTTPClient.Response.html#t:t/0","title":"ReverseProxyPlug.HTTPClient.Response.t/0","type":"type"},{"doc":"","ref":"ReverseProxyPlug.HTTPClient.Error.html","title":"ReverseProxyPlug.HTTPClient.Error","type":"exception"},{"doc":"","ref":"ReverseProxyPlug.HTTPClient.Error.html#message/1","title":"ReverseProxyPlug.HTTPClient.Error.message/1","type":"function"},{"doc":"","ref":"ReverseProxyPlug.HTTPClient.Error.html#t:t/0","title":"ReverseProxyPlug.HTTPClient.Error.t/0","type":"type"},{"doc":"","ref":"developing.html","title":"Releasing","type":"extras"},{"doc":"1. Bump the version according to semver\n2. Commit the version change, tag it with the version and push it to master\n3. Make a new GitHub release out of the tag, write the changelog\n4. Publish a new version of the Hex package according to [these\nsteps](https://hex.pm/docs/publish)","ref":"developing.html#releasing","title":"Releasing - Releasing","type":"extras"},{"doc":"# MIT License\n\nCopyright (c) 2018 Tallarium Technologies\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"# ReverseProxyPlug\n\n[![Module Version](https://img.shields.io/hexpm/v/reverse_proxy_plug.svg)](https://hex.pm/packages/reverse_proxy_plug)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/reverse_proxy_plug/)\n[![Total Download](https://img.shields.io/hexpm/dt/reverse_proxy_plug.svg)](https://hex.pm/packages/reverse_proxy_plug)\n[![License](https://img.shields.io/hexpm/l/reverse_proxy_plug.svg)](https://github.com/tallarium/reverse_proxy_plug/blob/master/LICENSE.md)\n[![Last Updated](https://img.shields.io/github/last-commit/tallarium/reverse_proxy_plug.svg)](https://github.com/tallarium/reverse_proxy_plug/commits/master)\n\nA reverse proxy plug for proxying a request to another URL using a choice of\nElixir HTTP client libraries. Perfect when you need to transparently proxy\nrequests to another service but also need to have full programmatic control\nover the outgoing requests.\n\nThis project grew out of a fork of\n[elixir-reverse-proxy](https://github.com/slogsdon/elixir-reverse-proxy).\nAdvantages over the original include more flexible upstreams, zero-delay\nchunked transfer encoding support, HTTP2 support with Cowboy 2, several options\nfor HTTP client libraries and focus on being a composable Plug instead of\nproviding a standalone reverse proxy application.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Add `reverse_proxy_plug` to your list of dependencies in `mix.exs`:\n```elixir\ndef deps do\n  [\n    {:reverse_proxy_plug, \"~> 3.0\"}\n  ]\nend\n```\n\nThen add an HTTP client library, one of:\n- [HTTPoison](https://hex.pm/packages/httpoison)\n- [Tesla](https://hex.pm/packages/tesla)\n- [Finch](https://hex.pm/packages/finch)\n- [Req](https://hex.pm/packages/req)\n\nand configure depending on your choice, e.g.:\n\n```elixir\nconfig :reverse_proxy_plug, :http_client, ReverseProxyPlug.HTTPClient.Adapters.HTTPoison\n```\n\nYou can also set the config as a per-plug basis, which will override any global config.\n\n```elixir\nplug ReverseProxyPlug, client: ReverseProxyPlug.HTTPClient.Adapters.Tesla\n```\n\nEither of those must be set, otherwise the system will attempt to default to the HTTPoison\nadapter or raise if it's not present.","ref":"readme.html#installation","title":"Installation - Overview","type":"extras"},{"doc":"The plug works best when used with\n[`Plug.Router.forward/2`](https://hexdocs.pm/plug/Plug.Router.html#forward/2).\nDrop this line into your Plug router:\n\n```elixir\nforward(\"/foo\", to: ReverseProxyPlug, upstream: \"//example.com/bar\")\n```\n\nNow all requests matching `/foo` will be proxied to the upstream. For\nexample, a request to `/foo/baz` made over HTTP will result in a request to\n`http://example.com/bar/baz`.\n\nYou can also specify the scheme or choose a port:\n```elixir\nforward(\"/foo\", to: ReverseProxyPlug, upstream: \"https://example.com:4200/bar\")\n```\n\nThe `:upstream` option should be a well formed URI parseable by [`URI.parse/1`](https://hexdocs.pm/elixir/URI.html#parse/1),\nor a function with zero or one arity which returns one. If it is a function, it will be\nevaluated for every request. If the function is arity one, the `Conn` struct will be\npassed to it, in order to have more flexibility in dynamic routing.","ref":"readme.html#usage","title":"Usage - Overview","type":"extras"},{"doc":"You can modify various aspects of the client request by simply modifying the\n`Conn` struct. In case you want to modify the request body, fetch it using\n`Conn.read_body/2`, make your changes, and leave it under\n`Conn.assigns[:raw_body]`. ReverseProxyPlug will use that as the request body.\nIn case a custom raw body is not present, ReverseProxyPlug will fetch it from\nthe `Conn` struct directly.","ref":"readme.html#modifying-the-client-request-body","title":"Modifying the client request body - Overview","type":"extras"},{"doc":"","ref":"readme.html#configuration-options","title":"Configuration options - Overview","type":"extras"},{"doc":"Only standard HTTP methods in \"GET\", \"HEAD\", \"POST\", \"PUT\", \"DELETE\", \"CONNECT\", \"OPTIONS\",\n\"TRACE\" and \"PATCH\" will be forwarded by default. You can specific define other custom\nHTTP methods in keyword :custom_http_methods.\n\n```elixir\nforward(\"/foo\", to: ReverseProxyPlug, upstream: \"//example.com/bar\", custom_http_methods: [:XMETHOD])\n```","ref":"readme.html#custom-http-methods","title":"Custom HTTP methods - Overview","type":"extras"},{"doc":"A reverse HTTP proxy often has to preserve the original `Host` request header\nwhen making a request to the upstream origin. Presenting a different `Host` to\nthe upstream server can lead to issues related to cookies, redirects, and\nincorrect routing that can become a security concern.\n\nSome HTTP proxies send the original `Host` value in other headers, like\n`Forwarded` or `X-Forwarded-Host`, but those are only useful if the upstream\napplication is coded to read those headers.\n\nBy default, ReverseProxyPlug does not preserve the original header nor does it\nsend the original header in any other form. Use `:preserve_host_header` to make\nupstream requests with the same `Host` header as in the original request.\n\n```elixir\nforward(\"/foo\", to: ReverseProxyPlug, upstream: \"//example.com\", preserve_host_header: true)\n```","ref":"readme.html#preserve-host-header","title":"Preserve host header - Overview","type":"extras"},{"doc":"An upstream request will downcase all request header names by default (`ReverseProxyPlug.downcase_headers/1`)\n\nYou can override this behaviour by passing your own `normalize_headers/1`, which can transform\na list of headers - a list of `{\"header\", \"value\"}` tuples - and return them in the form desired.\nFor instance, you may want to drop certain headers in the upstream request, beyond the usual hop-by-hop\nheaders.","ref":"readme.html#normalize-headers-for-upstream-request","title":"Normalize headers for upstream request - Overview","type":"extras"},{"doc":"`ReverseProxyPlug` supports two response modes:\n\n- `:stream` (default) - The response from the plug will always be chunk\nencoded. If the upstream server sends a chunked response, ReverseProxyPlug\nwill pass chunks to the clients as soon as they arrive, resulting in zero\ndelay. Not all adapters support the `:stream` response mode currently.\n\n- `:buffer` - The plug will wait until the whole response is received from\nthe upstream server, at which point it will send it to the client using\n`Conn.send_resp`. This allows for processing the response before sending it\nback using `Conn.register_before_send`.\n\nYou can choose the response mode by passing a `:response_mode` option:\n```elixir\nforward(\"/foo\", to: ReverseProxyPlug, response_mode: :buffer, upstream: \"//example.com/bar\")\n```","ref":"readme.html#response-mode","title":"Response mode - Overview","type":"extras"},{"doc":"You can specify the behaviour of how headers from the upstream response are incorporated\ninto the response that is sent from `reverse_proxy_plug`:\n- `:replace` - use `Conn.put_resp_header` to overwrite any existing headers present\n- `:prepend` - use `Conn.prepend_resp_header` to prepend headers from the upstream to existing\nresponse headers in `conn`.\n\nThe defaults differ per response mode - `:stream_headers_mode` defaults to `:replace`, `:buffer_headers_mode`\nto `:prepend`.","ref":"readme.html#response-header-processing-mode","title":"Response header processing mode - Overview","type":"extras"},{"doc":"You can pass options to the configured HTTP client. Valid options depend on the HTTP client used.\n\n```elixir\nforward(\"/foo\", to: ReverseProxyPlug, upstream: \"//example.com\", client_options: [timeout: 2000])\n```","ref":"readme.html#client-options","title":"Client options - Overview","type":"extras"},{"doc":"By default, `ReverseProxyPlug` will automatically respond with 502 Bad Gateway\nin case of network error. To inspect the HTTPoison error that caused the\nresponse, you can pass an `:error_callback` option.\n\n```elixir\nplug(ReverseProxyPlug,\n  upstream: \"example.com\",\n  error_callback: fn error -> Logger.error(\"Network error: #{inspect(error)}\") end\n)\n```\n\nIf you wish to handle the response directly, you can provide a function with\narity 2 where the connection will be passed as the second argument:\n\n```elixir\nplug(ReverseProxyPlug,\n  upstream: \"example.com\",\n  error_callback: fn error, conn ->\n    Logger.error(\"Network error: #{inspect(error)}\")\n    Plug.Conn.send_resp(conn, :internal_server_error, \"something went wrong\")\n  end)\n)\n```\n\nYou can also provide a MFA (module, function, arguments) tuple, to which the\nerror will be inserted as the last argument:\n\n```elixir\nplug(ReverseProxyPlug,\n  upstream: \"example.com\",\n  error_callback: {MyErrorHandler, :handle_proxy_error, [\"example.com\"]}\n)\n```\n\nIf the function specified by the MFA tuple supports two additional arguments,\nthe error and connection will inserted as the last two arguments, respectively.","ref":"readme.html#callback-for-connection-errors","title":"Callback for connection errors - Overview","type":"extras"},{"doc":"In order to add special handling for responses with particular statuses instead\nof passing them on to the client as usual, provide the `:status_callbacks`\noption with a map from status code to handler:\n\n```elixir\nplug(ReverseProxyPlug,\n  upstream: \"example.com\",\n  status_callbacks: %{404 => &handle_404/2}\n)\n```\n\nThe handler is called as soon as an `HTTPoison.AsyncStatus` message with the\ngiven status is received, taking the `Plug.Conn` and the options given to\n`ReverseProxyPlug`. It must then consume all the remaining incoming HTTPoison\nasynchronous response parts, respond to the client and return the `Plug.Conn`.\n\n`:status_callbacks` must only be given when `:response_mode` is `:stream`,\nwhich is the default.","ref":"readme.html#callbacks-for-responses-in-streaming-mode","title":"Callbacks for responses in streaming mode - Overview","type":"extras"},{"doc":"The Phoenix default autogenerated project assumes that you'll want to\nparse all request bodies coming to your Phoenix server and puts `Plug.Parsers`\ndirectly in your `endpoint.ex`. If you're using something like ReverseProxyPlug,\nthis is likely not what you want — in this case you'll want to move Plug.Parsers\nout of your endpoint and into specific router pipelines or routes themselves.\n\nOr you can extract the raw request body with a\n[custom body reader](https://hexdocs.pm/plug/1.6.0/Plug.Parsers.html#module-custom-body-reader)\nin your `endpoint.ex`:\n```elixir\nplug Plug.Parsers,\n  body_reader: {CacheBodyReader, :read_body, []},\n  # ...\n```\nand store it in the `Conn` struct with custom plug `cache_body_reader.ex`:\n```elixir\ndefmodule CacheBodyReader do\n  @moduledoc \"\"\"\n  Inspired by https://hexdocs.pm/plug/1.6.0/Plug.Parsers.html#module-custom-body-reader\n  \"\"\"\n\n  alias Plug.Conn\n\n  @doc \"\"\"\n  Read the raw body and store it for later use in the connection.\n  It ignores the updated connection returned by `Plug.Conn.read_body/2` to not break CSRF.\n  \"\"\"\n  @spec read_body(Conn.t(), Plug.opts()) :: {:ok, String.t(), Conn.t()}\n  def read_body(%Conn{request_path: \"/api/\" <> _} = conn, opts) do\n    {:ok, body, _conn} = Conn.read_body(conn, opts)\n    conn = update_in(conn.assigns[:raw_body], &[body | &1 || []])\n    {:ok, body, conn}\n  end\n\n  def read_body(conn, opts), do: Conn.read_body(conn, opts)\nend\n```\nwhich then allows you to use the [Phoenix.Router.forward/4](https://hexdocs.pm/phoenix/Phoenix.Router.html#forward/4)\nin the `router.ex`:\n```elixir\n  scope \"/api\" do\n    pipe_through :api\n\n    forward \"/foo\", ReverseProxyPlug,\n      upstream: &Settings.foo_url/0,\n      error_callback: &__MODULE__.log_reverse_proxy_error/1\n\n    def log_reverse_proxy_error(error) do\n      Logger.warn(\"ReverseProxyPlug network error: #{inspect(error)}\")\n    end\n  end\n```","ref":"readme.html#usage-in-phoenix","title":"Usage in Phoenix - Overview","type":"extras"},{"doc":"Copyright (c) 2018 Tallarium Technologies\n\nReverseProxyPlug is released under the [MIT License](./LICENSE.md).","ref":"readme.html#copyright-and-license","title":"Copyright and License - Overview","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}